/*
 * Obtaining the address of a function (-entry point).
 *
 * After inspecting the result of compiling this with
 *    cc -O2 -S -mdynamic-no-pic faddr.c
 * you will discover that external (e) and local (s) functions
 * are treated almost the same.  The only difference seems to be
 * the addition of some assembler directives (.non_lazy_symbol_pointer and
 * .indirect_symbol) in the external case.
 *
 * However, it appears that things work equally well if the address of s
 * is obtained the same way it would be if s were a variable instead of
 * a function, i.e.:
 *   _get_s:
 *      lis r3,ha16(_s)
 *      la  r3,lo16(_s)(r3)
 *      blr
 * See addr.[cs] for details.
 */
extern int e (int);
static int s (int x)
{
  return x + 1;
}

typedef int (*foo)(int);

foo get_e (void)
{
  return e;
}

foo get_s (void)
{
  return s;
}
